SystemOrganization addCategory: #'Pier-Book-Structures'!
SystemOrganization addCategory: #'Pier-Book-Utilities'!

PRStructure subclass: #BONote
	instanceVariableNames: 'email note timestamp'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:45'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOPublication! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionConfirmation
	^ MABooleanDescription new
		addCondition: (MACondition selector: #yourself)
			labelled: 'Please, confirm submission by clicking the checkbox';
		checkboxLabel: 'Confirm submission by clicking the checkbox';
		propertyAt: #public put: true;
		accessor: #confirmation;
		label: 'Confirmation';
		priority: 600;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:04'!
descriptionEmail
	^ MAStringDescription new
		addCondition: (MACondition selector: #matches: argument: '#*@#*.#*')
			labelled: 'Please make sure to enter a valid E-Mail';
	 	propertyAt: #public put: true;
		accessor: #email;
		label: 'E-Mail';
		priority: 500;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'descriptions' stamp: 'lr 5/3/2009 13:05'!
descriptionNote
	^ MAMemoDescription new
	 	propertyAt: #public put: true;
		accessor: #note;
		priority: 550;
		label: 'Note';
		lineCount: 5;
		beRequired;
		beEditable;
		yourself! !

!BONote class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:43'!
isAbstract
	^ false! !

!BONote class methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:42'!
label
	^ 'Book Note'! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:24'!
author
	^ self email copyUpTo: $@! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation
	^ false! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 13:05'!
confirmation: aBoolean! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:45'!
document
	^ PRDocument new
		add: (PRParagraph with: (PRText content: self author));
		add: (PRPreformatted withAll: (self note lines
			collect: [ :each | PRText content: each ]));
		yourself! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email
	^ email! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:24'!
email: aString 
	email := aString! !

!BONote methodsFor: 'initialization' stamp: 'lr 5/3/2009 12:29'!
initialize
	super initialize.
	email := String new.
	note := String new.
	timestamp := TimeStamp now! !

!BONote methodsFor: 'testing' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ true! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note
	^ note! !

!BONote methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:09'!
note: aString 
	note := aString! !

!BONote methodsFor: 'accessing-dynamic' stamp: 'lr 5/3/2009 12:29'!
timestamp
	^ timestamp! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 5/3/2009 12:10'!
isNote
	^ false! !

!PRStructure methodsFor: '*pier-book' stamp: 'lr 4/24/2009 11:56'!
isPublication
	^ false! !

PRLink subclass: #BOIndexLink
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:08'!
isAbstract
	^ false! !

!BOIndexLink class methodsFor: 'testing' stamp: 'lr 5/1/2009 22:09'!
isValidReference: aString
	^ aString beginsWith: 'index:'! !

!BOIndexLink methodsFor: 'visiting' stamp: 'lr 5/1/2009 22:09'!
accept: aVisitor
	aVisitor visitIndexLink: self! !

!BOIndexLink methodsFor: 'accessing' stamp: 'lr 5/1/2009 22:13'!
title
	^ super title copyAfter: $:! !

!PRLinkRenderer methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:35'!
visitIndexLink: aLink
	html anchor name: aLink title.
	parent visitAll: aLink children! !

!PRVisitor methodsFor: '*pier-book' stamp: 'lr 5/1/2009 22:11'!
visitIndexLink: aLink
	self visitLink: aLink! !

PRWidget subclass: #BONoteWidget
	instanceVariableNames: 'component command note'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Utilities'!

!BONoteWidget class methodsFor: 'testing' stamp: 'lr 5/3/2009 12:41'!
isAbstract
	^ false! !

!BONoteWidget class methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:41'!
label
	^ 'Book Notes'! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildCommand
	^ (self context
		structure: self note
		command: self note editCommandClass new)
			command! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:54'!
buildComponent
	^ (self buildDescription asComponentOn: self command)
		onAnswer: [ :result | self execute: result ];
		addValidatedForm;
		yourself! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:55'!
buildDescription
	^ self command description select: [ :each | each propertyAt: #public ifAbsent: [ false ] ]! !

!BONoteWidget methodsFor: 'private' stamp: 'lr 5/3/2009 12:56'!
buildNote
	^ BONote new
		title: self context structure title;
		yourself! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
children
	^ Array with: self component! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:55'!
command
	^ command ifNil: [ command := self buildCommand ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:54'!
component
	^ component ifNil: [ component := self buildComponent ]! !

!BONoteWidget methodsFor: 'actions' stamp: 'lr 5/3/2009 13:02'!
execute: anEditCommand
	| addCommand |
	note := component := command := nil.
	anEditCommand ifNil: [ ^ self ].
	addCommand := PRAddCommand new.
	self context command: addCommand.
	addCommand
		name: (addCommand
			uniqueName: 'note'
			in: self context structure);
		type: BONote;
		beUnchecked;
		execute.
	self context
		structure: addCommand answer structure
		command: anEditCommand.
	anEditCommand
		beUnchecked;
		execute! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:57'!
note
	^ note ifNil: [ note := self buildNote ]! !

!BONoteWidget methodsFor: 'accessing' stamp: 'lr 5/3/2009 12:40'!
notes
	^ (self context enumerator
		select: [ :each | each isNote ])
		asSortedCollection: [ :a :b | a timestamp > b timestamp ]! !

!BONoteWidget methodsFor: 'rendering-adding' stamp: 'lr 5/3/2009 17:09'!
renderAddOn: html
	html div class: 'addnote'; with: [
		html heading: 'Add a Note'.
		html render: self component ]! !

!BONoteWidget methodsFor: 'rendering' stamp: 'lr 5/3/2009 17:08'!
renderContentOn: html
	(BONote canBeChildOf: self context structure class)
		ifFalse: [ ^ self ].
	html div class: 'notes'; with: [
		self renderNotes: self notes on: html.
		self renderAddOn: html ]! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 12:25'!
renderNote: aNote on: html
	html div class: 'note'; with: [ 
		self renderNoteMeta: aNote on: html.
		self renderNoteBody: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 17:01'!
renderNoteBody: aNote on: html
	| line |
	html div class: 'body'; with: [
		aNote note lines do: [ :string |
			line := string.
			html paragraph: [
				[ line notEmpty and: [ line first = $ ] ]
					whileTrue: [ html space. line := line copyWithoutFirst ].
				html text: line ] ] ]! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 12:33'!
renderNoteMeta: aNote on: html 
	html div class: 'meta'; with: [
		self renderNoteMetaAuthor: aNote on: html.
		self renderNoteMetaPublication: aNote on: html.
		self renderNoteMetaCommands: aNote on: html ]! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 12:32'!
renderNoteMetaAuthor: aNote on: html.
	html span
		class: 'author';
		with: aNote author.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 12:48'!
renderNoteMetaCommands: aNote on: html
	| commands contexts |
	commands := Array with: PREditCommand with: PRMoveCommand with: PRRemoveCommand.
	contexts := (commands
		collect: [ :class | self context structure: aNote command: class new ])
		select: [ :each | each isValid ].
	contexts isEmpty ifTrue: [ ^ self ].
	html span class: 'commands'; with: [
		contexts
			do: [ :each | html anchor goto: each; with: each command label ]
			separatedBy: [ html text: ', ' ] ].
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 13:10'!
renderNoteMetaPublication: aNote on: html 
	html span
		class: 'publication';
		with: '(' , aNote timestamp date printString , 
			', ' , aNote timestamp time printMinutes ,
			')'.
	html text: ' '! !

!BONoteWidget methodsFor: 'rendering-notes' stamp: 'lr 5/3/2009 17:08'!
renderNotes: aCollection on: html
	aCollection isEmpty
		ifFalse: [ html heading: 'User Contributed Notes' ].
	aCollection do: [ :each |
		self renderNote: each on: html ]! !

PRCase subclass: #BOBook
	instanceVariableNames: 'subtitle tagline authors'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:35'!
canBeChildOf: aStructureClass
	^ ((aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPublication ]) not! !

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 12:44'!
canBeParentOf: aStructureClass
	^ aStructureClass isKindOf: BOChapter! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:38'!
descriptionAuthors
	^ MAStringDescription new
		parameterName: 'authors';
		accessor: #authors;
		label: 'Authors';
		beSearchable;
		priority: 400;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionSubtitle
	^ MAStringDescription new
		parameterName: 'subtitle';
		accessor: #subtitle;
		label: 'Subtitle';
		beSearchable;
		priority: 200;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'descriptions' stamp: 'lr 4/23/2009 19:37'!
descriptionTagline
	^ MAStringDescription new
		parameterName: 'tagline';
		accessor: #tagline;
		label: 'Tagline';
		beSearchable;
		priority: 300;
		beEditable;
		yourself! !

!BOBook class methodsFor: 'testing' stamp: 'lr 5/2/2009 12:33'!
isAbstract
	^ false! !

!BOBook class methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:31'!
label
	^ 'Book'! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors
	^ authors! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
authors: anObject
	authors := anObject! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
index
	^ nil! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:25'!
isBook
	^ true! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isChapter
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isPart
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isPublication
	^ true! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isSection
	^ false! !

!BOBook methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isSubsection
	^ false! !

!BOBook methodsFor: 'accessing-dynamic' stamp: 'lr 5/2/2009 21:39'!
number
	^ nil! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle
	^ subtitle! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
subtitle: aString
	subtitle := aString! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline
	^ tagline! !

!BOBook methodsFor: 'accessing' stamp: 'lr 4/23/2009 19:38'!
tagline: aString
	tagline := aString! !

PRCase subclass: #BOPublication
	instanceVariableNames: 'numbered'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

BOPublication subclass: #BOChapter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOChapter class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:36'!
canBeChildOf: aStructureClass
	^ (aStructureClass includesBehavior: BOBook) or: [ aStructureClass includesBehavior: BOPart ]! !

!BOChapter class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Chapter'! !

!BOChapter methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:14'!
index
	"Answer the chapter of this publication. Chapters can be on different levels, thus we need different numbering algorithm."
	
	| root siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	root := self parent
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	siblings := root enumerator everything
		select: [ :each | each isPublication and: [ each isChapter and: [ each isNumbered ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOChapter methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isChapter
	^ true! !

BOPublication subclass: #BOPart
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOPart class methodsFor: 'testing' stamp: 'lr 5/2/2009 15:15'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOBook! !

!BOPart class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:37'!
label
	^ 'Book Part'! !

!BOPart methodsFor: 'private' stamp: 'lr 5/2/2009 15:56'!
arabicToRoman: anInteger
	"Convert an arabic integer to a roman string."
	
	| number roman |
	number := anInteger.
	roman := WriteStream on: String new.
	#((1000 'M') (900 'CM') (500 'D') (400 'CD') (100 'C') (90 'XC') (50 'L') (40 'XL') (10 'X') (9 'IX') (5 'V') (4 'IV') (1 'I')) do: [ :pair |
		[ number >= pair first ] whileTrue: [
			roman nextPutAll: pair second.
			number := number - pair first ] ].
	^ roman contents! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:28'!
index
	^ nil! !

!BOPart methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ true! !

!BOPart methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:56'!
number
	^ self arabicToRoman: super index! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 4/24/2009 12:20'!
descriptionNumber
	^ MAStringDescription new
		parameterName: 'number';
		accessor: #number;
		beReadonly;
		yourself! !

!BOPublication class methodsFor: 'descriptions' stamp: 'lr 5/2/2009 16:13'!
descriptionNumbered
	^ MABooleanDescription new
		accessor: #numbered;
		label: 'Numbered';
		default: true;
		priority: 150;
		beEditable;
		yourself! !

!BOPublication class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:21'!
isAbstract
	^ self name = #POPublication! !

!BOPublication methodsFor: 'comparing' stamp: 'lr 4/24/2009 12:10'!
< aStructure
	| siblings |
	(self parent isNil or: [ self parent ~= aStructure parent ])
		ifTrue: [ ^ super < aStructure ].
	(aStructure isPublication)
		ifFalse: [ ^ false ].
	siblings := self parent childrenDecoration children.
	^ (siblings indexOf: self) < (siblings indexOf: aStructure)
		! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:14'!
index
	"Answer the index number of this publication, for example the chapter or section number."
	
	| siblings |
	self parent isNil
		ifTrue: [ ^ nil ].
	siblings := self parent childrenDecoration children select: [ :each | 
		each isPublication 
			and: [ each isNumbered
			and: [ each class = self class ] ] ].
	^ siblings indexOf: self ifAbsent: [ nil ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:26'!
isBook
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:40'!
isChapter
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 16:13'!
isNumbered
	^ numbered ifNil: [ true ]! !

!BOPublication methodsFor: 'testing' stamp: 'lr 5/2/2009 15:14'!
isPart
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/23/2009 19:32'!
isPublication
	^ true! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ false! !

!BOPublication methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ false! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:33'!
number
	"Answer the composed numbers."

	| book publications |
	book := self 
		findAncestor: [ :each | each isPublication and: [ each isBook ] ]
		ifAbsent: [ ^ nil ].
	publications := (self parents
		select: [ :each | each isPublication ])
		copyAfter: book.
	^ (((publications	
		collect: [ :each | each index ])
		reject: [ :each | each isNil ])
		collect: [ :each | each asString ])
		reduce: [ :a :b | a , '.' , b ]! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:13'!
numbered
	^ numbered! !

!BOPublication methodsFor: 'accessing' stamp: 'lr 5/2/2009 16:12'!
numbered: aBoolean
	numbered := aBoolean! !

BOPublication subclass: #BOSection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:34'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOChapter! !

!BOSection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Section'! !

!BOSection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSection
	^ true! !

BOPublication subclass: #BOSubsection
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Pier-Book-Structures'!

!BOSubsection class methodsFor: 'testing' stamp: 'lr 4/23/2009 19:33'!
canBeChildOf: aStructureClass
	^ aStructureClass includesBehavior: BOSection! !

!BOSubsection class methodsFor: 'accessing' stamp: 'lr 5/2/2009 15:36'!
label
	^ 'Book Subsection'! !

!BOSubsection methodsFor: 'testing' stamp: 'lr 4/24/2009 11:41'!
isSubsection
	^ true! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 16:21'!
bookContentsIn: aContext
	<value: 'book.contents' comment: 'Display a table of contents.'>

	| result |
	^ self lookupStructure: aContext structure do: [ :root |
		result := PRDefinitionList new.
		root enumerator everything do: [ :structure |
			(structure isPublication and: [ structure isBook not ]) ifTrue: [
				self 
					bookLabel: (structure number 
						ifNil: [ ' ' ])
					target: structure 
					to: result ] ].
		result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 16:29'!
bookIndexIn: aContext
	<value: 'book.index' comment: 'Display an index of keywords.'>

	| structs |
	^ self lookupStructure: aContext structure do: [ :root |
		| index |
		index := Dictionary new.
		root enumerator everything do: [ :struct |
			struct outgoingReferences do: [ :refer |
				(refer isKindOf: BOIndexLink) ifTrue: [ 
					(index at: refer title ifAbsentPut: [ OrderedCollection new ])
						addLast: refer owner ] ] ].
		(index keys asSortedCollection: [ :a :b | a asLowercase < b asLowercase ])
			inject: PRDefinitionList new
			into: [ :list :word |
				structs := Set new.
				list add: (PRTermItem with: (PRText content: word)).
				(index at: word) do: [ :struct |
					(structs includes: struct) ifFalse: [ 
						structs add: struct.
						list add: (PRDataItem with: (PRInternalLink new
							anchor: word;
							target: struct;
							yourself)) ] ].
				list ] ]! !

!PRValueLink methodsFor: '*pier-book-private' stamp: 'lr 5/2/2009 21:35'!
bookLabel: aString target: aStructure to: aDefinitionList
	| number |
	^ aDefinitionList
		add: (PRTermItem with: (PRText content: (aStructure isNil
			ifTrue: [ '&nbsp;' ]
			ifFalse: [ aString ])));
		add: (PRDataItem with: (aStructure isNil
			ifTrue: [ PRText content: '&nbsp;' ]
			ifFalse: [
				number := aStructure number.
				number isNil 
					ifTrue: [ number := String new ]
					ifFalse: [ number := number , ' ' ].
				PRInternalLink new 
					parameterAt: 'title' put: number , aStructure title;
					target: aStructure;
					yourself ]));
		yourself! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 09:56'!
bookNavigationIn: aContext
	<value: 'book.navigation' comment: 'Display a navigation structure for books.'>

	| structures index result |
	^ self lookupStructure: aContext structure do: [ :structure |
		structures := (aContext enumeratorFor: aContext root) everything
			select: [ :each | each isPublication ].
		index := structures indexOf: (structure 
			findAncestor: [ :each | each isPublication ]).
		result := PRDefinitionList new.
		self 
			bookLabel: '&rarr;' target: (structures at: index + 1 ifAbsent: [ nil ]) to: result;
			bookLabel: '&larr;' target: (structures at: index - 1 ifAbsent: [ nil ]) to: result ]! !

!PRValueLink methodsFor: '*pier-book' stamp: 'lr 5/2/2009 10:06'!
bookParentIn: aContext
	<value: 'book.parent' comment: 'Display the parent structure for books.'>

	^ self lookupStructure: aContext structure do: [ :structure |
		self 
			bookLabel: '&sect;' 
			target: (structure isRoot
				ifFalse: [ structure parent findAncestor: [ :each | each isPublication ] ]) 
			to: PRDefinitionList new ]! !
